"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

TValueBinding subclass:#TConstantBinding
	instanceVariableNames:'value'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler-Bindings'
!

!TConstantBinding class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
! !

!TConstantBinding class methodsFor:'instance creation'!

value: anObject
    ^ self new initializeWithValue: anObject

    "Created: / 20-09-2015 / 07:11:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TConstantBinding methodsFor:'accessing'!

value
    ^ value
! !

!TConstantBinding methodsFor:'converting'!

asLLVMValueInModule: aLLVMModule
    value isInteger ifTrue:[ 
        ^ LLVMConstant sint: value type: (type asLLVMTypeInModule: aLLVMModule ).
    ].
    ^ self notYetImplemented

    "Created: / 03-09-2015 / 07:07:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TConstantBinding methodsFor:'initialization'!

initializeWithValue: anObject
    value := anObject.

    "Created: / 20-09-2015 / 07:11:37 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TConstantBinding methodsFor:'testing'!

isConstantBinding
    ^ true
! !

!TConstantBinding class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

